open Syntax;;
open Parser_helper;;
open General_helper;;

let exp_true  = parse "fun x -> fun y -> x";;
let exp_false = parse "fun x -> fun y -> y";;
let exp_ite   = parse "fun b -> fun t -> fun e -> ((b t) e)"

let context = Ctx [ ];; (* Do not need context here *)

let print_and_reduce s =
  let t = parse s in begin
      print_string "\n";
      print_string (term_to_string t);
      print_string (green_string " --β--> ");
      print_string (term_to_string (reduce t context));
      print_string "\n";
    end;;

let main =
  print_and_reduce "(fun x -> x) (fun y -> y)";
  print_and_reduce "if true then false else true";
  print_string "\n";
;;
