%{
  open Syntax
%}

%token <int> INT
%token <string> VAR
%token TRUE FALSE SUCC BEQUAL EQUAL
%token LPAREN RPAREN LBRACKET RBRACKET
%token LAMBDA LET IN IF THEN ELSE ARROW ISZERO
%token EOF

%start expr
%type <Syntax.term> expr
%%

expr:
| expr expr_noapp              { TmApp ($1,$2) }
| expr_noapp                   { $1 }
;

expr_noapp:
| SUCC expr                    { TmVar "succ"  (* TmSucc $2 *) }
| ISZERO expr                  { TmVar "isz"   (* TmIsZ $2 *) }
| IF expr THEN expr ELSE expr  { TmApp (TmApp (TmApp (TmVar "if", $2), $4), $6)    (* TmIf ($2,$4,$6) *) }
| LAMBDA VAR ARROW expr        { TmAbs ($2,$4) }
| VAR                          { TmVar $1 }
| INT                          { int_to_term $1 }
| TRUE                         { TmTrue }
| FALSE                        { TmFalse }
| LPAREN expr RPAREN           { $2 }
;
